----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    22:46:17 05/21/2009 
-- Design Name: 
-- Module Name:    romdemux - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity romdemux is
    Port ( CLK : in  STD_LOGIC;
           DH : out  STD_LOGIC_VECTOR (7 downto 0);
			  DL : in STD_LOGIC_VECTOR (7 downto 0);
			  CE : in STD_LOGIC;
           RDn : in  STD_LOGIC;
           READY : out  STD_LOGIC;
           ROMA0 : out  STD_LOGIC;
           ROMEn : out  STD_LOGIC);
end romdemux;

architecture Behavioral of romdemux is
	type stanje_type is (spreman,
								preread11, preread12, preread13,
								read1,
								preread21, preread22, preread23,
								read2, done
								);
	signal stanje : stanje_type := spreman;
	signal internal_ce : STD_LOGIC;
begin

	process (CLK, internal_ce)
	begin
		if (internal_ce = '0') then
			stanje <= spreman;
			ROMA0 <= '1';
			DH <= (others=>'Z');
		elsif (rising_edge(CLK)) then
			case stanje is
				when spreman =>
				
				-- ubačena 3 stanja kako bi pristup bio 50/(3+1)MHz
					stanje <= preread11;
				when preread11 =>
					stanje <= preread12;
				when preread12 =>
					stanje <= preread13;
				when preread13 =>

					stanje <= read1;
				when read1 =>
					DH <= DL;
					ROMA0 <= '0';
					
				-- ubačena stanja iz istog razloga
					stanje <= preread21;
				when preread21 =>
					stanje <= preread22;
				when preread22 =>
					stanje <= preread23;
				when preread23 =>
				
					stanje <= read2;
				when read2 =>
					stanje <= done;
				when done =>
					stanje <= done;
					
				when others =>
					stanje <= spreman;
			end case;
		end if;
	end process;
	
	internal_ce <= CE and (not RDn);
	ROMEn <= not internal_ce;
	READY <= '1' when stanje = done or stanje = spreman else '0';
	
end Behavioral;

