----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    20:05:22 09/16/2009 
-- Design Name: 
-- Module Name:    spi - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity spi is
    Port ( CLK : in  STD_LOGIC;
           RST : in  STD_LOGIC;
           D : inout  STD_LOGIC_VECTOR (7 downto 0);
           DREG : in  STD_LOGIC;
           SREG : in  STD_LOGIC;
           WR : in  STD_LOGIC;
           SCK : out  STD_LOGIC;
           MISO : in  STD_LOGIC;
           MOSI : out  STD_LOGIC;
           INT : out  STD_LOGIC);
end spi;

architecture Behavioral of spi is

	signal spickcont, spick : STD_LOGIC;
	signal start : STD_LOGIC;
	signal busy : STD_LOGIC;
	
	signal reg : STD_LOGIC_VECTOR(7 downto 0);
	signal bitcount : STD_LOGIC_VECTOR(3 downto 0);

begin

	INT <= not busy;
	
	start <= WR and DREG;
	
	-- djeljenje CLK s 2
	process (CLK, busy, start)
		variable diver : STD_LOGIC_VECTOR(0 downto 0);
	begin
		if (busy = '0' or start = '1') then
			diver := "0";
		elsif (rising_edge(CLK)) then
			diver := diver + 1;
		end if;

		spickcont <= diver(0);
	end process;
	
--	-- 8 taktova
--	process (RST, spickcont, start)
--		variable bitid : integer range 0 to 8;
--	begin
--		if (RST = '1') then
--			bitid := 8;
--		elsif (start = '1') then
--			bitid := 0;
--		elsif (falling_edge(spickcont)) then
--			if (bitid /= 8) then
--				bitid := bitid + 1;
--			end if;
--		end if;
--		
--tmpbitid <= bitid;
--		if (bitid = 8) then
--			SCK <= '1';
--			spick <= '0';
--			busy <= '0';
--		else
--			SCK <= spickcont;
--			spick <= spickcont;
--			busy <= '1';
--		end if;
--		
--		if (RST = '1') then
--			SCK <= 'Z';
--		end if;
--	end process;

--	-- 8 taktova
--	process (RST, spickcont, start)
--		variable bitid : integer range 0 to 8;
--	begin
--		if (RST = '1') then
--			busy <= '0';
--			bitid := 8;
--		elsif (start = '1') then
--			bitid := 0;
--		elsif (falling_edge(start)) then
--			busy <= '1';
--		elsif (falling_edge(spickcont)) then
----			if (busy = '1') then
----				if (bitid = 8) then
----					busy <= '0';
----				end if;
--				bitid := bitid + 1;
----			end if;
--		end if;
--		
--tmpbitid <= bitid;
--		if (bitid = 8) then
--			SCK <= '1';
--			spick <= '0';
----			busy <= '0';
--		else
--			SCK <= spickcont;
--			spick <= spickcont;
----			busy <= '1';
--		end if;
--		
--		if (RST = '1') then
--			SCK <= 'Z';
--		end if;
--	end process;
--	
--	-- glavni
--	process (RST, SREG, DREG, WR, start, D, spick, busy)
--		variable reg : STD_LOGIC_VECTOR(7 downto 0);
--	begin
--		-- reset, shift & write
--		if (start = '1') then
--			reg := D;
--		elsif (falling_edge(spick)) then
--			reg := reg(6 downto 0) & MISO;
--		end if;
--		
--		MOSI <= reg(7);
--		
--		-- čitanje je uvijek moguće
--		if (SREG = '1' and WR = '0') then
--			D <= ("0100000" & busy);
--		elsif (DREG = '1' and WR = '0') then
--			D <= reg;
--		else
--			D <= (others => 'Z');
--		end if;
--		
--		if (RST = '1') then
--			MOSI <= 'Z';
--		end if;
--	end process;


	process(RST, start, D, busy, spickcont)
	begin
		-- reset, shift & write
		if (RST = '1') then
			busy <= '0';
			spick <= '1';
		elsif (start = '1') then
			busy <= '1';
			reg <= D;
			bitcount <= "0000";
		elsif (rising_edge(spickcont)) then	-- spickcont čeka da nestane start
			if (busy = '1') then
				spick <= bitcount(0);
				
				if (bitcount(0) = '1') then
					reg <= reg(6 downto 0) & MISO;
				end if;
				
				if (bitcount = "1111") then
					busy <= '0';
				end if;

				bitcount <= bitcount + 1;
			end if;
		end if;
	end process;

	-- izlazni signali moraju biti Z dok je RST
	MOSI	<= reg(7)	when RST = '0' else 'Z';
	SCK	<= spick		when RST = '0' else 'Z';

	-- čitanje registra je uvijek moguće
	D <=	("0100000" & busy)	when SREG = '1' and WR = '0' else
			reg						when DREG = '1' and WR = '0' else
			(others => 'Z');

end Behavioral;
